
//Copyright (C) 2010-2020  Henk Jegers
//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//You should have received a copy of the GNU General Public License
//along with this program.  If not, see <http://www.gnu.org/licenses/>.

//This software uses DMD2.
//for questions email to info@archeryclock.com  

// version Submatrix001 Initial version with reuse of MEGA02_1 (Ledstrip version)

//settings
String language = "Eng"; // "Eng" for English, "Dut" for Dutch. 


#include <SPI.h>
#include <DMD2.h>

#include <fonts/SystemFont5x7.h>
#include <fonts/Arial14.h>
#include <fonts/ACFont11x16.h>
#include <fonts/ACFont16x16.h>
#include <fonts/ACFont20x16.h>


SoftDMD dmd(2,1);  // DMD controls the entire display

String inputString;
int serialvalue;
int statevalue; //received data for state details.
int shtrs14value; //ABCD data shooters 1 to 4
int shtrs56value; //ABCD data shooters 5 and 6
int state; //state
int Atype =9; // type of match (fita, 25m1p, etc.)
int turn; //turn

int shtrs; //nr of shooters per end
int shtrsperturn; //nr of shooters per turn
char shtr1val; //value shooter 1 (ABC...)
char shtr2val; //value shooter 2 (ABC...)
char shtr3val; //value shooter 3 (ABC...)
char shtr4val; //value shooter 4 (ABC...)
char shtr5val; //value shooter 5 (ABC...)
char shtr6val; //value shooter 6 (ABC...)
int shtrAval; //Remember if shooter A bit was true;
int shtrBval; //Remember if shooter B bit was true;
int shtrCval; //Remember if shooter C bit was true;
int shtrDval; //Remember if shooter D bit was true;
int shtrEval; //Remember if shooter E bit was true;
int shtrFval; //Remember if shooter F bit was true;
int shtr25mval; //value of 25m1p shooter (1..6)
String finarcher; // to indicate during alternating if none, left or righ archer is selected
int trafficvalue; //received data for traffic lights, and ABCD lights
char stopbrightup='N';
int stopbrightval=255;
int leftcountvalue; //received data for left countdown.
int rightcountvalue; //received data for rightcountdown.
int abcdvalue;   //received data for abcd details
int endnrvalue;  //received data for end nr



int rightdigit; //value of left digit   (0..10  (10 means dashes))
int middigit; //value of middle digit (0..10  (10 means dashes))
int leftdigit; //value of light digit  (0..10  (10 means dashes))

int lefend; //value of left digit to indicate end nr  (0..9 or 15  (15 means P to indicate practise end))
int midend; //value of middle digit to indicate end nr  (0..9)
int rigend; //value of middle digit to indicate end nr  (0..9)
int comend; //value of combined left and middle digit. In case of practise end the P from the left digit should be projected. else the middle digit (0..9 or 15  (15 means P to indicate practise end)) 

int segment[16]={0x03f,0x006,0x05b,0x04f,0x066,0x06d,0x07d,0x007,0x07f,0x06f,0x040,0x000,0x03f,0x000,0x000,0x073}; //0,1,2,3,4,5,6,7,8,9,-, , , , ,P

void setup() {
  
  DDRC = B00000000;               // Pins A0 to A5 are inputs

  pinMode(14, OUTPUT);
  pinMode(15, OUTPUT);
  pinMode(16, OUTPUT);
  pinMode(17, OUTPUT);
  pinMode(18, OUTPUT);
  pinMode(19, OUTPUT);
  pinMode(20, OUTPUT);
  pinMode(21, OUTPUT);
  //pinMode(22, OUTPUT);
  pinMode(23, OUTPUT);
  //pinMode(24, OUTPUT);
  pinMode(25, OUTPUT);
  //pinMode(26, OUTPUT);
  pinMode(27, OUTPUT);
  //pinMode(28, OUTPUT);
  pinMode(29, OUTPUT);
  //pinMode(30, OUTPUT);
  //pinMode(31, OUTPUT);
  //pinMode(32, OUTPUT);
  //pinMode(33, OUTPUT);
  //pinMode(34, OUTPUT);
  //pinMode(35, OUTPUT);
  //pinMode(36, OUTPUT);
  //pinMode(37, OUTPUT);
  //pinMode(38, OUTPUT);
  pinMode(39, OUTPUT);
  //pinMode(40, OUTPUT);
  pinMode(41, OUTPUT);
  //pinMode(42, OUTPUT);
  pinMode(43, OUTPUT);
  //pinMode(44, OUTPUT);
  pinMode(45, OUTPUT);
  //pinMode(46, OUTPUT);
  pinMode(47, OUTPUT);
  //pinMode(48, OUTPUT);
  pinMode(49, OUTPUT);
  //pinMode(50, OUTPUT);
  pinMode(51, OUTPUT);
  //pinMode(52, OUTPUT);
  pinMode(53, OUTPUT);
  pinMode(A8, OUTPUT);
  pinMode(A9, OUTPUT);
  pinMode(A10, OUTPUT);
  pinMode(A11, OUTPUT);
  pinMode(A12, OUTPUT);
  pinMode(A13, OUTPUT);
  pinMode(A14, OUTPUT);
  pinMode(A15, OUTPUT);




  rightcountvalue=0xAAA0;
  leftcountvalue=0xAAA0;
  serialvalue=0x0000;
  
  Serial.begin(9600);
  Serial.println("Arduino Serial Link");
  Serial.println("connected!") ;
  
  dmd.setBrightness(255);
  dmd.selectFont(SystemFont5x7);
  dmd.begin();

}

void loop() {
  inputString = "";               // Clear inputString
  if(Serial.available()){
    while ((Serial.available())) {
      char digit = Serial.read();   // Read serial buffer
      if(digit != '\n'){inputString += digit;};         // Add new character to the string inputString
      delay(2);                     // Let the serial buffer catch its breath.
      serialvalue = inputString.toInt();
    };
   
//16 bits data received. 
//first bit is telling if the data is about traffic lights and ABCD lights (true). or about the digits of the countdown (false). 
//second bit is telling:
//    -in case of digits (first bit is 0)if the digits are from the right side countdown (true) or left side countdown (false).
//    -in case of trafic/ABCD lights: not implemented jet. Proposal is to use this for ABCD light depending on sequence (For example CDAB is also possible to show)
    
//filter data strings:  
    if((serialvalue&0x01) && not(serialvalue&0x06)){ trafficvalue=serialvalue;};     //traficlights
    if ((not(serialvalue&0x01)) && ((serialvalue&0x02)or (serialvalue&0x04))){rightcountvalue=serialvalue;};     //determine the timing string of the rightside timer
    if ((not(serialvalue&0x01)) && ((not(serialvalue&0x02))or (serialvalue&0x04))){leftcountvalue=serialvalue;}; //determine the timing string of the leftside timer
    if((serialvalue&0x01) && (serialvalue&0x02) && (serialvalue&0x04)&& not(serialvalue&0x08)){ endnrvalue=serialvalue;};     //endnr info
    if((serialvalue&0x01) && (serialvalue&0x02) && (serialvalue&0x04)&& (serialvalue&0x08)){ statevalue=serialvalue;};     //state info containing state, archery type and turn number
    if((serialvalue&0x01) && (serialvalue&0x02)&& not(serialvalue&0x0C)){shtrs14value=serialvalue;};                       //shooter 1 to 4 details (A, B, C, D, E or F)
    if((serialvalue&0x01) && (serialvalue&0x02)&& not(serialvalue&0x04)&& (serialvalue&0x08)){shtrs56value=serialvalue;};  //shooter 5 to 6 details (A, B, C, D, E or F)
    

//filter end number out of endnr string    
    lefend=((endnrvalue>>4)&B00001111);  //based on 3 digits including "P", this is the left digit
    midend=((endnrvalue>>8)&B00001111);  //based on 3 digits including "P", this is the middle digit
    rigend=((endnrvalue>>12)&B00001111); //based on 3 digits including "P", this is the right digit
    if (lefend==15){comend=lefend;}else {comend=midend;}; //combine left and middle digit in one. Meaning in case of "P" the left digit is used


//filter info out of string data strings
    state=((statevalue>>4)&B00000111);  //state. Means prepare shooting state, red, yellow or green state, emergency state, etc
    Atype=((statevalue>>7)&B00000111);  //Archery type meaning indoor outdoor, alternating, 25m1p etc.
    turn=((statevalue>>10)&B00000111);  // turn number
    shtrs=((statevalue>>13)&B00000111)+1; //number of shooters per end

//filter info out of frafficvalue string    
    shtrsperturn=((trafficvalue>>10)&B00000001)+((trafficvalue>>11)&B00000001)+((trafficvalue>>12)&B00000001)+((trafficvalue>>13)&B00000001)+((trafficvalue>>14)&B00000001)+((trafficvalue>>15)&B00000001); //number of shooters per turn

    if ((trafficvalue>>10)&B00000001){shtrAval=1;}else{shtrAval=11;}; //Verify if shooter A active
    if ((trafficvalue>>11)&B00000001){shtrBval=2;}else{shtrBval=11;}; //Verify if shooter B active
    if ((trafficvalue>>12)&B00000001){shtrCval=3;}else{shtrCval=11;}; //Verify if shooter C active
    if ((trafficvalue>>13)&B00000001){shtrDval=4;}else{shtrDval=11;}; //Verify if shooter D active
    if ((trafficvalue>>14)&B00000001){shtrEval=5;}else{shtrEval=11;}; //Verify if shooter E active
    if ((trafficvalue>>15)&B00000001){shtrFval=6;}else{shtrFval=11;}; //Verify if shooter F active

    if ((((shtrs14value>>4)&B00000111)==shtrAval)or(((shtrs14value>>4)&B00000111)==shtrBval)or(((shtrs14value>>4)&B00000111)==shtrCval)or(((shtrs14value>>4)&B00000111)==shtrDval)or(((shtrs14value>>4)&B00000111)==shtrEval)or(((shtrs14value>>4)&B00000111)==shtrFval)){shtr1val=((shtrs14value>>4)&B00000111)+64;}else{shtr1val=((shtrs14value>>4)&B00000111)+96;}; //Verifiy if shooter1 is active. And identify who is shooter1
    if ((((shtrs14value>>7)&B00000111)==shtrAval)or(((shtrs14value>>7)&B00000111)==shtrBval)or(((shtrs14value>>7)&B00000111)==shtrCval)or(((shtrs14value>>7)&B00000111)==shtrDval)or(((shtrs14value>>7)&B00000111)==shtrEval)or(((shtrs14value>>7)&B00000111)==shtrFval)){shtr2val=((shtrs14value>>7)&B00000111)+64;}else{shtr2val=((shtrs14value>>7)&B00000111)+96;}; //Verifiy if shooter2 is active. And identify who is shooter2
    if ((((shtrs14value>>10)&B00000111)==shtrAval)or(((shtrs14value>>10)&B00000111)==shtrBval)or(((shtrs14value>>10)&B00000111)==shtrCval)or(((shtrs14value>>10)&B00000111)==shtrDval)or(((shtrs14value>>10)&B00000111)==shtrEval)or(((shtrs14value>>10)&B00000111)==shtrFval)){shtr3val=((shtrs14value>>10)&B00000111)+64;}else{shtr3val=((shtrs14value>>10)&B00000111)+96;}; //Verifiy if shooter3 is active. And identify who is shooter3
    if ((((shtrs14value>>13)&B00000111)==shtrAval)or(((shtrs14value>>13)&B00000111)==shtrBval)or(((shtrs14value>>13)&B00000111)==shtrCval)or(((shtrs14value>>13)&B00000111)==shtrDval)or(((shtrs14value>>13)&B00000111)==shtrEval)or(((shtrs14value>>13)&B00000111)==shtrFval)){shtr4val=((shtrs14value>>13)&B00000111)+64;}else{shtr4val=((shtrs14value>>13)&B00000111)+96;}; ////Verifiy if shooter4 is active. And identify who is shooter4
    if ((((shtrs56value>>4)&B00000111)==shtrAval)or(((shtrs56value>>4)&B00000111)==shtrBval)or(((shtrs56value>>4)&B00000111)==shtrCval)or(((shtrs56value>>4)&B00000111)==shtrDval)or(((shtrs56value>>4)&B00000111)==shtrEval)or(((shtrs56value>>4)&B00000111)==shtrFval)){shtr5val=((shtrs56value>>4)&B00000111)+64;}else{shtr5val=((shtrs56value>>4)&B00000111)+96;}; //Verifiy if shooter5 is active. And identify who is shooter5
    if ((((shtrs56value>>7)&B00000111)==shtrAval)or(((shtrs56value>>7)&B00000111)==shtrBval)or(((shtrs56value>>7)&B00000111)==shtrCval)or(((shtrs56value>>7)&B00000111)==shtrDval)or(((shtrs56value>>7)&B00000111)==shtrEval)or(((shtrs56value>>7)&B00000111)==shtrFval)){shtr6val=((shtrs56value>>7)&B00000111)+64;}else{shtr6val=((shtrs56value>>7)&B00000111)+96;}; //Verifiy if shooter6 is active. And identify who is shooter6

    if ((trafficvalue>>10)&B00000001){shtr25mval=1;}; //Verify if 25m1p shooter is shooter 1
    if ((trafficvalue>>11)&B00000001){shtr25mval=2;}; //Verify if 25m1p shooter is shooter 2
    if ((trafficvalue>>12)&B00000001){shtr25mval=3;}; //Verify if 25m1p shooter is shooter 3
    if ((trafficvalue>>13)&B00000001){shtr25mval=4;}; //Verify if 25m1p shooter is shooter 4
    if ((trafficvalue>>14)&B00000001){shtr25mval=5;}; //Verify if 25m1p shooter is shooter 5
    if ((trafficvalue>>15)&B00000001){shtr25mval=6;}; //Verify if 25m1p shooter is shooter 6
    finarcher="none";
    if ((trafficvalue>>14)&B00000001){finarcher="right";};  //verify if alternating shooter is right side
    if ((trafficvalue>>15)&B00000001){finarcher="left";};   //verify if alternating shooter is left side
    
  };


 
  
  
  if (digitalRead(A4)){ //buzzer yes/no switch
     digitalWrite(25,  (trafficvalue&0x0008)?HIGH:LOW);        //buzzer 3 pins used pin 25, 26 and 27 for higher current. (1500mA)
     digitalWrite(27,  (trafficvalue&0x0008)?HIGH:LOW);
     digitalWrite(29,  (trafficvalue&0x0008)?HIGH:LOW);
  }else{
     digitalWrite(25, LOW);                                    //if switch on A4 is off, buzzer must be always off
     digitalWrite(27, LOW);
     digitalWrite(29, LOW);

  } ;
  
   
//outputs depending on switch (A5 input) if right side or leftside is used

  if (digitalRead(A5)){  //right side
    //Trafic lights:
    digitalWrite(14,  (trafficvalue&0x0010)?HIGH:LOW);        //green right side
    digitalWrite(A15,  (trafficvalue&0x0020)?HIGH:LOW);        //orange right side
    digitalWrite(39,  (trafficvalue&0x0040)?HIGH:LOW);        //red right side
    //digits
    digitalWrite(23,  ((rightcountvalue&0x0008)?HIGH:LOW)and((segment[leftdigit]==0x040)?LOW:HIGH) );      //dots to indicate minutes or seconds indication
    rightdigit=((rightcountvalue>>4)&B00001111);  
    middigit=((rightcountvalue>>8)&B00001111);
    leftdigit=((rightcountvalue>>12)&B00001111);
  }
  else  //left side
  {
    //Trafic lights:
    digitalWrite(14,  (trafficvalue&0x0080)?HIGH:LOW);        //green left side
    digitalWrite(A15,  (trafficvalue&0x0100)?HIGH:LOW);        //orange left side
    digitalWrite(39,  (trafficvalue&0x0200)?HIGH:LOW);        //red left side
    //digits
    digitalWrite(23,  ((leftcountvalue&0x0008)?HIGH:LOW)and((segment[leftdigit]==0x040)?LOW:HIGH) );      //dots to indicate minutes or seconds indication
    rightdigit=((leftcountvalue>>4)&B00001111);
    middigit=((leftcountvalue>>8)&B00001111);
    leftdigit=((leftcountvalue>>12)&B00001111);
  };

if (((turn==0)or(shtrsperturn==0))and(Atype!=2)){
  dmd.drawFilledBox(0,0,8,7, GRAPHICS_OFF);
  dmd.drawFilledBox(0,8,4,15, GRAPHICS_OFF);
  dmd.drawFilledBox(0,7,63,8, GRAPHICS_OFF);
  dmd.drawFilledBox(57,0,63,7, GRAPHICS_OFF);
  dmd.drawFilledBox(59,8,63,15, GRAPHICS_OFF);
  
  dmd.selectFont(SystemFont5x7);
  dmd.drawString(9,0,"ARCHERY-");
  dmd.drawString(5,9,"CLOCK.COM");

  }else{

  if (state==6) { //alarmstate
    dmd.selectFont(ACFont16x16);
    if (stopbrightup=='Y'){stopbrightval=stopbrightval+1;}else{stopbrightval=stopbrightval-10;};
    if (stopbrightval<5){stopbrightup=='Y';};
    if (stopbrightval>254){stopbrightup=='N';};
    dmd.setBrightness(stopbrightval);
    dmd.drawString(0,0,"STOP");  // print STOP
  }
  else{
    dmd.setBrightness(255);
    if ((Atype==0)or(Atype==6)){  //TOP-Bottom modus
      dmd.selectFont(ACFont11x16);
      if (((turn==1)and (shtr1val=='A'))or((turn==2)and (shtr2val=='A'))){  //detect if Top or Bottom needs to shoot
        if (language=="Eng"){dmd.drawString(-1,0,"BOTTOM");};
        if (language=="Dut"){
          dmd.drawFilledBox(0,0,3,16, GRAPHICS_OFF);
          dmd.drawFilledBox(60,0,64,16, GRAPHICS_OFF);          
          dmd.drawString(5,0,"ONDER");
          }; 
      }else{
        if (language=="Eng"){
          dmd.drawFilledBox(0,0,15,16, GRAPHICS_OFF);
          dmd.drawFilledBox(49,0,64,16, GRAPHICS_OFF);
          dmd.drawString(16,0,"TOP");
          };
        if (language=="Dut"){
          dmd.drawFilledBox(0,0,3,16, GRAPHICS_OFF);
          dmd.drawFilledBox(60,0,64,16, GRAPHICS_OFF);          
          dmd.drawString(5,0,"BOVEN");
          };                 
      }
    };
    if ((Atype==1)or(Atype==7)){  //indoor outdoor
      if (shtrs<5){dmd.selectFont(ACFont16x16);}else{dmd.selectFont(ACFont11x16);};    //size of font depend on number of characters to print
      if (shtrs==1){dmd.drawString(0,0,"    ");};                                      //print nothing (remove existing text) since there is only one archer per end
      if (shtrs==2){dmd.drawString(0,0," "+String(shtr1val)+String(shtr2val)+" ");};   //Print 2 archers  
      if (shtrs==3){                                                                   //print 3 archers. remove characters left and right side
        dmd.drawFilledBox(0,0,6,16, GRAPHICS_OFF);
        dmd.drawFilledBox(56,0,64,16, GRAPHICS_OFF);
        dmd.drawString(8,0,String(shtr1val)+String(shtr2val)+String(shtr3val));        
        };
      if (shtrs==4){dmd.drawString(0,0,String(shtr1val)+String(shtr2val)+String(shtr3val)+String(shtr4val));};   // print 4 archers
      if (shtrs==5){                                                                                            //print 5 archers. remove characters left and right side
        dmd.drawFilledBox(0,0,3,16, GRAPHICS_OFF);
        dmd.drawFilledBox(60,0,64,16, GRAPHICS_OFF);          
        dmd.drawString(5,0,String(shtr1val)+String(shtr2val)+String(shtr3val)+String(shtr4val)+String(shtr5val));
      };
      if (shtrs==6){dmd.drawString(-1,0,String(shtr1val)+String(shtr2val)+String(shtr3val)+String(shtr4val)+String(shtr5val)+String(shtr6val));};   // print 6 archers

    }
    if (Atype==2){ //alternating
      dmd.selectFont(ACFont20x16);
      if (finarcher=="none"){     //remove arrows
        dmd.drawString(0,0,"=");  
        dmd.drawString(44,0,"=");
      }
      if (finarcher=="left"){
        dmd.drawString(0,0,"<");  //print left arrow
        dmd.drawString(44,0,"="); //remove right arrow
      }
      if (finarcher=="right"){
        dmd.drawString(0,0,"=");  //remove left arrow
        dmd.drawString(44,0,">"); //print right arrow
      }
      dmd.selectFont(ACFont11x16);
      if ((comend==12)or(comend==10)or(comend==14)or(comend==15)){comend=0;};
      if ((rigend==12)or(rigend==10)){rigend=0;};
      if (comend==0){             // if end nr is one digit, print in de middle, remove left and right left overs.
        dmd.drawFilledBox(21,0,25,16, GRAPHICS_OFF);
        dmd.drawFilledBox(38,0,42,16, GRAPHICS_OFF);
        dmd.drawString(27,0,String(rigend));
      }else{                                 //print 2 endnrcharacters
        dmd.drawString(21,0,String(comend));
        dmd.drawString(32,0,String(rigend));
      }      
    }
    if (Atype==3){   //25m1p
      dmd.selectFont(Arial14);
      dmd.drawFilledBox(0,0,51,4, GRAPHICS_OFF);
      
      if (language=="Eng"){
        dmd.drawFilledBox(51,0,52,16, GRAPHICS_OFF);
        dmd.drawString(0,5," Archer");
      };
      if (language=="Dut"){
        dmd.drawFilledBox(50,0,52,16, GRAPHICS_OFF);
        dmd.drawString(0,5,"Schutter");
      };
      dmd.selectFont(ACFont11x16);
      dmd.drawString(53,0,String(shtr25mval));  
    }
    if ((Atype==4)or((Atype==0)and(turn==0))){ // Manual mode, remove all text
      dmd.drawFilledBox(0,0,63,16, GRAPHICS_OFF);
    }
  };
  };    
  digitalWrite(21, ((segment[leftdigit]&0x001))?HIGH:LOW); //left digit segment A
  digitalWrite(20, ((segment[leftdigit]&0x002))?HIGH:LOW); //left digit segment B
  digitalWrite(19, ((segment[leftdigit]&0x004))?HIGH:LOW); //left digit segment C
  digitalWrite(18, ((segment[leftdigit]&0x008))?HIGH:LOW); //left digit segment D
  digitalWrite(17, ((segment[leftdigit]&0x010))?HIGH:LOW); //left digit segment E
  digitalWrite(16, ((segment[leftdigit]&0x020))?HIGH:LOW); //left digit segment F
  digitalWrite(15, ((segment[leftdigit]&0x040))?HIGH:LOW); //left digit segment G


  digitalWrite(53, ((segment[middigit]&0x001))?HIGH:LOW); //middle digit segment A
  digitalWrite(51, ((segment[middigit]&0x002))?HIGH:LOW); //middle digit segment B
  digitalWrite(49, ((segment[middigit]&0x004))?HIGH:LOW); //middle digit segment C
  digitalWrite(47, ((segment[middigit]&0x008))?HIGH:LOW); //middle digit segment D
  digitalWrite(45, ((segment[middigit]&0x010))?HIGH:LOW); //middle digit segment E
  digitalWrite(43, ((segment[middigit]&0x020))?HIGH:LOW); //middle digit segment F
  digitalWrite(41, ((segment[middigit]&0x040))?HIGH:LOW); //middle digit segment G

    
  digitalWrite(A8, ((segment[rightdigit]&0x001))?HIGH:LOW); //right digit segment A
  digitalWrite(A9, ((segment[rightdigit]&0x002))?HIGH:LOW); //right digit segment B
  digitalWrite(A10, ((segment[rightdigit]&0x004))?HIGH:LOW); //right digit segment C
  digitalWrite(A11, ((segment[rightdigit]&0x008))?HIGH:LOW); //right digit segment D
  digitalWrite(A12, ((segment[rightdigit]&0x010))?HIGH:LOW); //right digit segment E
  digitalWrite(A13, ((segment[rightdigit]&0x020))?HIGH:LOW); //right digit segment F
  digitalWrite(A14, ((segment[rightdigit]&0x040))?HIGH:LOW); //right digit segment G
 

   
}
  
